import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { InjectionToken, Directive, Inject, Optional, Component, ChangeDetectionStrategy, Pipe, Input, inject, NgModule } from '@angular/core';
import * as i1 from '@angular/forms';
import { FormsModule, ReactiveFormsModule, Validators } from '@angular/forms';
import * as i2$1 from '@ng-bootstrap/ng-bootstrap';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import * as i2 from 'ng-deco-forms';
import { FIELD_PROP_KEY_TOKEN, FIELD_FORM_CONTROL_TOKEN, FIELD_CONFIG_TOKEN, DecoFormsLibModule, DecoField, chain, Prop, addValidator, Wrap, Provide, targetConfig, Class, PropFactory, Validator, FORM_SUBMIT_TOKEN } from 'ng-deco-forms';
import { of } from 'rxjs';

const LABEL_FOR_FACTORY_TOKEN = new InjectionToken('label-for-factory');
class ForDirective {
    constructor(fieldKey, elementRef) {
        this.fieldKey = fieldKey;
        this.elementRef = elementRef;
        elementRef.nativeElement.setAttribute('for', fieldKey + "-id");
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: ForDirective, deps: [{ token: FIELD_PROP_KEY_TOKEN }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.4", type: ForDirective, selector: "label", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: ForDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'label'
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_PROP_KEY_TOKEN]
                }] }, { type: i0.ElementRef }]; } });

class IdDirective {
    constructor(fieldKey, elementRef) {
        this.fieldKey = fieldKey;
        this.elementRef = elementRef;
        elementRef.nativeElement.id = fieldKey + "-id";
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: IdDirective, deps: [{ token: FIELD_PROP_KEY_TOKEN }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.4", type: IdDirective, selector: "input,textarea,select", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: IdDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input,textarea,select'
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_PROP_KEY_TOKEN]
                }] }, { type: i0.ElementRef }]; } });

const PLACEHOLDER_FACTORY_TOKEN = new InjectionToken('placeholder-factory');
class PlaceholderDirective {
    constructor(factory = () => '', elementRef) {
        this.factory = factory;
        this.elementRef = elementRef;
        elementRef.nativeElement.setAttribute('placeholder', factory?.() ?? '');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: PlaceholderDirective, deps: [{ token: PLACEHOLDER_FACTORY_TOKEN, optional: true }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.4", type: PlaceholderDirective, selector: "input,textarea", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: PlaceholderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input,textarea'
                }]
        }], ctorParameters: function () { return [{ type: Function, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PLACEHOLDER_FACTORY_TOKEN]
                }] }, { type: i0.ElementRef }]; } });

const LABEL_TOKEN = new InjectionToken('LABEL_TOKEN');
class SelectPlaceholderDirective {
    constructor(label, elementRef) {
        this.label = label;
        this.elementRef = elementRef;
        elementRef.nativeElement.innerText = label + "...";
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: SelectPlaceholderDirective, deps: [{ token: LABEL_TOKEN }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.4", type: SelectPlaceholderDirective, selector: "[selectPlaceholder]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: SelectPlaceholderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[selectPlaceholder]'
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [LABEL_TOKEN]
                }] }, { type: i0.ElementRef }]; } });

class CheckboxTypeComponent {
    constructor(control) {
        this.control = control;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: CheckboxTypeComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: CheckboxTypeComponent, selector: "deco-checkbox-type", ngImport: i0, template: "<input\n  class=\"deco-checkbox\"\n  type=\"checkbox\"\n  [formControl]=\"control\"\n>\n", dependencies: [{ kind: "directive", type: i1.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.ChangeDirective, selector: "[formGroup],[formControl],[formArray]" }, { kind: "directive", type: IdDirective, selector: "input,textarea,select" }, { kind: "directive", type: PlaceholderDirective, selector: "input,textarea" }], changeDetection: i0.ChangeDetectionStrategy.Default }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: CheckboxTypeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-checkbox-type', changeDetection: ChangeDetectionStrategy.Default, template: "<input\n  class=\"deco-checkbox\"\n  type=\"checkbox\"\n  [formControl]=\"control\"\n>\n" }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }]; } });

class HiddenComponent {
    constructor(control) {
        this.control = control;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: HiddenComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: HiddenComponent, selector: "deco-hidden", ngImport: i0, template: "<input type=\"hidden\" name=\"\" [formControl]=\"control\">", styles: [""], dependencies: [{ kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.ChangeDirective, selector: "[formGroup],[formControl],[formArray]" }, { kind: "directive", type: IdDirective, selector: "input,textarea,select" }, { kind: "directive", type: PlaceholderDirective, selector: "input,textarea" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: HiddenComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-hidden', template: "<input type=\"hidden\" name=\"\" [formControl]=\"control\">" }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }]; } });

class NumberTypeComponent {
    constructor(control, config) {
        this.control = control;
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: NumberTypeComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN }, { token: FIELD_CONFIG_TOKEN, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: NumberTypeComponent, selector: "deco-number-type", ngImport: i0, template: "<input\n  class=\"deco-number\"\n  type=\"number\"\n  [formControl]=\"control\"\n  [step]=\"config.step\"\n  [min]=\"config.min\"\n  [max]=\"config.max\"\n>\n", dependencies: [{ kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.MinValidator, selector: "input[type=number][min][formControlName],input[type=number][min][formControl],input[type=number][min][ngModel]", inputs: ["min"] }, { kind: "directive", type: i1.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.ChangeDirective, selector: "[formGroup],[formControl],[formArray]" }, { kind: "directive", type: IdDirective, selector: "input,textarea,select" }, { kind: "directive", type: PlaceholderDirective, selector: "input,textarea" }], changeDetection: i0.ChangeDetectionStrategy.Default }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: NumberTypeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-number-type', changeDetection: ChangeDetectionStrategy.Default, template: "<input\n  class=\"deco-number\"\n  type=\"number\"\n  [formControl]=\"control\"\n  [step]=\"config.step\"\n  [min]=\"config.min\"\n  [max]=\"config.max\"\n>\n" }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

class SelectTypeComponent {
    get valueChange() {
        return this.control.valueChanges;
    }
    constructor(control, config) {
        this.control = control;
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: SelectTypeComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN }, { token: FIELD_CONFIG_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: SelectTypeComponent, selector: "deco-select-type", ngImport: i0, template: "<select\n  class=\"deco-select\"\n  [formControl]=\"control\"\n  [class.gray]=\"!(valueChange | async)\"\n  [class.black]=\"valueChange | async\"\n>\n  <option\n    [ngValue]=\"null\"\n    [disabled]=\"true\"\n    hidden\n    selectPlaceholder\n  >\n    <!-- {{ field.placeholder | placeholder }} -->\n  </option>\n  <option\n    *ngFor=\"let option of (config.options$ | async)\"\n    [ngValue]=\"option.id\"\n  >\n    {{ option.name }}\n  </option>\n</select>\n", styles: [".gray{color:gray}.black{color:#000}option:not(:first-of-type){color:#000}\n"], dependencies: [{ kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.ChangeDirective, selector: "[formGroup],[formControl],[formArray]" }, { kind: "directive", type: IdDirective, selector: "input,textarea,select" }, { kind: "directive", type: SelectPlaceholderDirective, selector: "[selectPlaceholder]" }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.Default }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: SelectTypeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-select-type', changeDetection: ChangeDetectionStrategy.Default, template: "<select\n  class=\"deco-select\"\n  [formControl]=\"control\"\n  [class.gray]=\"!(valueChange | async)\"\n  [class.black]=\"valueChange | async\"\n>\n  <option\n    [ngValue]=\"null\"\n    [disabled]=\"true\"\n    hidden\n    selectPlaceholder\n  >\n    <!-- {{ field.placeholder | placeholder }} -->\n  </option>\n  <option\n    *ngFor=\"let option of (config.options$ | async)\"\n    [ngValue]=\"option.id\"\n  >\n    {{ option.name }}\n  </option>\n</select>\n", styles: [".gray{color:gray}.black{color:#000}option:not(:first-of-type){color:#000}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

class TextTypeComponent {
    constructor(control) {
        this.control = control;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: TextTypeComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: TextTypeComponent, selector: "deco-text-type", ngImport: i0, template: "<input\n  class=\"deco-text\"\n  type=\"text\"\n  [formControl]=\"control\"\n>\n", dependencies: [{ kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.ChangeDirective, selector: "[formGroup],[formControl],[formArray]" }, { kind: "directive", type: IdDirective, selector: "input,textarea,select" }, { kind: "directive", type: PlaceholderDirective, selector: "input,textarea" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: TextTypeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-text-type', template: "<input\n  class=\"deco-text\"\n  type=\"text\"\n  [formControl]=\"control\"\n>\n" }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }]; } });

class TextAreaTypeComponent {
    constructor(control, config = { rows: 4 }) {
        this.control = control;
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: TextAreaTypeComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN }, { token: FIELD_CONFIG_TOKEN, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: TextAreaTypeComponent, selector: "deco-textarea-type", ngImport: i0, template: "<textarea\n  autosize\n  class=\"deco-textarea\"\n  [formControl]=\"control\"\n  [rows]=\"config.rows\"\n>\n</textarea>\n", dependencies: [{ kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.ChangeDirective, selector: "[formGroup],[formControl],[formArray]" }, { kind: "directive", type: IdDirective, selector: "input,textarea,select" }, { kind: "directive", type: PlaceholderDirective, selector: "input,textarea" }], changeDetection: i0.ChangeDetectionStrategy.Default }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: TextAreaTypeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-textarea-type', changeDetection: ChangeDetectionStrategy.Default, template: "<textarea\n  autosize\n  class=\"deco-textarea\"\n  [formControl]=\"control\"\n  [rows]=\"config.rows\"\n>\n</textarea>\n" }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

class ErrorPipe {
    transform(value, ...args) {
        if (!value)
            return '';
        if (value.required)
            return 'This field is required';
        if (value.minlength)
            return `This field must be at least ${value.minlength.requiredLength} characters long`;
        if (value.maxlength)
            return `This field must be at most ${value.maxlength.requiredLength} characters long`;
        if (value.min)
            return `This field must be at least ${value.min.min}`;
        if (value.max)
            return `This field must be at most ${value.max.max}`;
        if (value.email)
            return `This field must be a valid email address`;
        const keys = Object.keys(value);
        return value[keys[0]];
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: ErrorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: ErrorPipe, name: "error" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: ErrorPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'error'
                }]
        }] });

const SUBMIT_CONFIG_TOKEN = new InjectionToken('field-submit');
class SubmitComponent {
    constructor(config) {
        this.config = config;
    }
    ngAfterViewInit() {
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: SubmitComponent, deps: [{ token: FIELD_CONFIG_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: SubmitComponent, selector: "deco-submit", ngImport: i0, template: "<deco-group></deco-group>\n<button type=\"submit\" class=\"btn {{config.btnClass}}\" >{{config.label}}</button>", styles: [""], dependencies: [{ kind: "component", type: i2.GroupComponent, selector: "deco-group" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: SubmitComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-submit', template: "<deco-group></deco-group>\n<button type=\"submit\" class=\"btn {{config.btnClass}}\" >{{config.label}}</button>" }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

class CheckboxLabelWrapperComponent {
    constructor(config) {
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: CheckboxLabelWrapperComponent, deps: [{ token: FIELD_CONFIG_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: CheckboxLabelWrapperComponent, selector: "deco-checkbox-label-wrapper", ngImport: i0, template: "<div class=\"deco-checkbox-label__container\">\n  <ng-content></ng-content>\n  <label\n    class=\"deco-checkbox-label__text\">{{config.label}}</label>\n</div>\n", dependencies: [{ kind: "directive", type: ForDirective, selector: "label" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: CheckboxLabelWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-checkbox-label-wrapper', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"deco-checkbox-label__container\">\n  <ng-content></ng-content>\n  <label\n    class=\"deco-checkbox-label__text\">{{config.label}}</label>\n</div>\n" }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

const FIELD_TOOLTIP_TOKEN = new InjectionToken('field-tooltip');
class TooltipsComponent {
    get statusChanges() {
        return this.control.statusChanges;
    }
    get errors() {
        return this.control.errors;
    }
    constructor(control) {
        this.control = control;
    }
    ngOnInit() {
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: TooltipsComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: TooltipsComponent, selector: "deco-tooltips", inputs: { warning$: ["warning", "warning$"], tooltip: "tooltip" }, ngImport: i0, template: "<i\n    *ngIf=\"(warning$ | async) as warning\"\n    [ngbTooltip]=\"warning\"\n    [tooltipClass]=\"'warning-tooltip'\"\n    placement=\"top\"\n    [ngClass]=\"'icon warning bi bi-exclamation-triangle-fill me-1'\"\n></i>\n<i\n    *ngIf=\"(statusChanges | async)== 'INVALID' && control.dirty\"\n    [ngbTooltip]=\"errors | error\"\n    [tooltipClass]=\"'danger-tooltip'\"\n    placement=\"top\"\n    [ngClass]=\"'icon danger bi bi-exclamation-octagon-fill me-1'\"\n></i>\n<i\n    *ngIf=\"tooltip\"\n    [ngbTooltip]=\"tooltip\"\n    placement=\"top\"\n    [ngClass]=\"'icon info bi bi-info-circle-fill'\"\n></i>\n", styles: [".icon{width:16px;display:inline-block;height:16px}.info{color:#136c87}.danger{color:#dc3545}.warning{color:#ffc107}\n"], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2$1.NgbTooltip, selector: "[ngbTooltip]", inputs: ["animation", "autoClose", "placement", "popperOptions", "triggers", "positionTarget", "container", "disableTooltip", "tooltipClass", "openDelay", "closeDelay", "ngbTooltip"], outputs: ["shown", "hidden"], exportAs: ["ngbTooltip"] }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }, { kind: "pipe", type: ErrorPipe, name: "error" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: TooltipsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-tooltips', template: "<i\n    *ngIf=\"(warning$ | async) as warning\"\n    [ngbTooltip]=\"warning\"\n    [tooltipClass]=\"'warning-tooltip'\"\n    placement=\"top\"\n    [ngClass]=\"'icon warning bi bi-exclamation-triangle-fill me-1'\"\n></i>\n<i\n    *ngIf=\"(statusChanges | async)== 'INVALID' && control.dirty\"\n    [ngbTooltip]=\"errors | error\"\n    [tooltipClass]=\"'danger-tooltip'\"\n    placement=\"top\"\n    [ngClass]=\"'icon danger bi bi-exclamation-octagon-fill me-1'\"\n></i>\n<i\n    *ngIf=\"tooltip\"\n    [ngbTooltip]=\"tooltip\"\n    placement=\"top\"\n    [ngClass]=\"'icon info bi bi-info-circle-fill'\"\n></i>\n", styles: [".icon{width:16px;display:inline-block;height:16px}.info{color:#136c87}.danger{color:#dc3545}.warning{color:#ffc107}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }]; }, propDecorators: { warning$: [{
                type: Input,
                args: ['warning']
            }], tooltip: [{
                type: Input,
                args: ['tooltip']
            }] } });

class FieldLabelWrapperComponent {
    constructor(config) {
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: FieldLabelWrapperComponent, deps: [{ token: FIELD_CONFIG_TOKEN, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: FieldLabelWrapperComponent, selector: "deco-field-label-wrapper", ngImport: i0, template: "<div class=\"deco-field-label\">\n  <div class=\"deco-field-label__label\">\n    <label\n      *ngIf=\"config.label\"\n      class=\"deco-field-label__text\"\n    >{{ config.label }}</label>\n    <deco-tooltips [tooltip]=\"config.tooltip\" [warning]=\"config.warning$\"></deco-tooltips>\n  </div>\n\n  <div class=\"deco-field-label__field\" decoWarning>\n    <ng-content></ng-content>\n  </div>\n</div>\n", dependencies: [{ kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: ForDirective, selector: "label" }, { kind: "component", type: TooltipsComponent, selector: "deco-tooltips", inputs: ["warning", "tooltip"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: FieldLabelWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-field-label-wrapper', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"deco-field-label\">\n  <div class=\"deco-field-label__label\">\n    <label\n      *ngIf=\"config.label\"\n      class=\"deco-field-label__text\"\n    >{{ config.label }}</label>\n    <deco-tooltips [tooltip]=\"config.tooltip\" [warning]=\"config.warning$\"></deco-tooltips>\n  </div>\n\n  <div class=\"deco-field-label__field\" decoWarning>\n    <ng-content></ng-content>\n  </div>\n</div>\n" }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

class HideFieldWrapperComponent {
    constructor(config) {
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: HideFieldWrapperComponent, deps: [{ token: FIELD_CONFIG_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: HideFieldWrapperComponent, selector: "deco-hide-field-wrapper", ngImport: i0, template: "<ng-container *ngIf=\"!(config.hide$ | async)\">\n    <ng-content></ng-content>\n</ng-container>\n", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: HideFieldWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-hide-field-wrapper', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!(config.hide$ | async)\">\n    <ng-content></ng-content>\n</ng-container>\n" }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

class NestedDropdownComponent {
    constructor(control, config) {
        this.control = control;
        this.config = config;
    }
    ngOnInit() {
        this.options$ = this.config.level == 0 ? this.config.options$ : of(this.options);
    }
    moveToTheRight(popperOptions) {
        const options = {
            ...popperOptions,
            placement: 'right-start'
        };
        return options;
    }
    stayOnBotton(popperOptions) {
        return popperOptions;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: NestedDropdownComponent, deps: [{ token: FIELD_FORM_CONTROL_TOKEN }, { token: FIELD_CONFIG_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: NestedDropdownComponent, selector: "lib-nested-dropdown", inputs: { options: "options" }, providers: [
            {
                provide: FIELD_CONFIG_TOKEN,
                useFactory: () => {
                    const config = inject(FIELD_CONFIG_TOKEN, { skipSelf: true, optional: true });
                    return {
                        ...config,
                        level: config.level >= 0 ? config.level + 1 : 0
                    };
                }
            }
        ], ngImport: i0, template: "<div *ngIf=\"options$ | async as options\" [ngClass]=\"{'dropend': config.level > 0, \n    'toggle-align-end': config.level > 0}\"  ngbDropdown #dropdown=\"ngbDropdown\"\n    [popperOptions]=\"config.level == 0  ? stayOnBotton : moveToTheRight\">\n    <button ngbDropdownItem type=\"button\" class=\"btn btn-sm\"\n    style=\"width: max-content; display: inline-block;\"\n      >{{'kkkkkkk'}}</button>\n      <button *ngIf=\"options && options.length > 0\" type=\"button\"\n        ngbDropdownToggle class=\"btn btn-sm dropdown-toggle\">\n      </button>\n    <div ngbDropdownMenu >\n      <div *ngIf=\"dropdown.isOpen()\">\n        <lib-nested-dropdown *ngFor=\"let opt of options\"\n            [options]=\"opt.children\" ></lib-nested-dropdown>\n      </div>\n    </div>\n  </div>\n  ", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2$1.NgbDropdown, selector: "[ngbDropdown]", inputs: ["autoClose", "dropdownClass", "open", "placement", "popperOptions", "container", "display"], outputs: ["openChange"], exportAs: ["ngbDropdown"] }, { kind: "directive", type: i2$1.NgbDropdownToggle, selector: "[ngbDropdownToggle]" }, { kind: "directive", type: i2$1.NgbDropdownMenu, selector: "[ngbDropdownMenu]" }, { kind: "directive", type: i2$1.NgbDropdownItem, selector: "[ngbDropdownItem]", inputs: ["disabled"] }, { kind: "component", type: NestedDropdownComponent, selector: "lib-nested-dropdown", inputs: ["options"] }, { kind: "pipe", type: i1$1.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: NestedDropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-nested-dropdown', providers: [
                        {
                            provide: FIELD_CONFIG_TOKEN,
                            useFactory: () => {
                                const config = inject(FIELD_CONFIG_TOKEN, { skipSelf: true, optional: true });
                                return {
                                    ...config,
                                    level: config.level >= 0 ? config.level + 1 : 0
                                };
                            }
                        }
                    ], template: "<div *ngIf=\"options$ | async as options\" [ngClass]=\"{'dropend': config.level > 0, \n    'toggle-align-end': config.level > 0}\"  ngbDropdown #dropdown=\"ngbDropdown\"\n    [popperOptions]=\"config.level == 0  ? stayOnBotton : moveToTheRight\">\n    <button ngbDropdownItem type=\"button\" class=\"btn btn-sm\"\n    style=\"width: max-content; display: inline-block;\"\n      >{{'kkkkkkk'}}</button>\n      <button *ngIf=\"options && options.length > 0\" type=\"button\"\n        ngbDropdownToggle class=\"btn btn-sm dropdown-toggle\">\n      </button>\n    <div ngbDropdownMenu >\n      <div *ngIf=\"dropdown.isOpen()\">\n        <lib-nested-dropdown *ngFor=\"let opt of options\"\n            [options]=\"opt.children\" ></lib-nested-dropdown>\n      </div>\n    </div>\n  </div>\n  " }]
        }], ctorParameters: function () { return [{ type: i1.FormControl, decorators: [{
                    type: Inject,
                    args: [FIELD_FORM_CONTROL_TOKEN]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; }, propDecorators: { options: [{
                type: Input,
                args: ['options']
            }] } });

class DecoFormsBootstrapModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: DecoFormsBootstrapModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: DecoFormsBootstrapModule, declarations: [HideFieldWrapperComponent,
            SubmitComponent,
            SelectTypeComponent,
            TextAreaTypeComponent,
            TextTypeComponent,
            CheckboxTypeComponent,
            NumberTypeComponent,
            HiddenComponent,
            FieldLabelWrapperComponent,
            IdDirective,
            ForDirective,
            PlaceholderDirective,
            CheckboxLabelWrapperComponent,
            SelectPlaceholderDirective,
            TooltipsComponent,
            ErrorPipe,
            NestedDropdownComponent], imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            DecoFormsLibModule,
            NgbModule], exports: [HideFieldWrapperComponent,
            SubmitComponent,
            SelectTypeComponent,
            TextAreaTypeComponent,
            TextTypeComponent,
            CheckboxTypeComponent,
            NumberTypeComponent,
            NestedDropdownComponent,
            HiddenComponent,
            FieldLabelWrapperComponent,
            CheckboxLabelWrapperComponent,
            IdDirective,
            ForDirective,
            PlaceholderDirective,
            SelectPlaceholderDirective,
            ErrorPipe,
            DecoFormsLibModule,
            NgbModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: DecoFormsBootstrapModule, imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            DecoFormsLibModule,
            NgbModule, DecoFormsLibModule,
            NgbModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: DecoFormsBootstrapModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        HideFieldWrapperComponent,
                        SubmitComponent,
                        SelectTypeComponent,
                        TextAreaTypeComponent,
                        TextTypeComponent,
                        CheckboxTypeComponent,
                        NumberTypeComponent,
                        HiddenComponent,
                        FieldLabelWrapperComponent,
                        IdDirective,
                        ForDirective,
                        PlaceholderDirective,
                        CheckboxLabelWrapperComponent,
                        SelectPlaceholderDirective,
                        TooltipsComponent,
                        ErrorPipe,
                        NestedDropdownComponent
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        DecoFormsLibModule,
                        NgbModule
                    ],
                    exports: [
                        HideFieldWrapperComponent,
                        SubmitComponent,
                        SelectTypeComponent,
                        TextAreaTypeComponent,
                        TextTypeComponent,
                        CheckboxTypeComponent,
                        NumberTypeComponent,
                        NestedDropdownComponent,
                        HiddenComponent,
                        FieldLabelWrapperComponent,
                        CheckboxLabelWrapperComponent,
                        IdDirective,
                        ForDirective,
                        PlaceholderDirective,
                        SelectPlaceholderDirective,
                        ErrorPipe,
                        DecoFormsLibModule,
                        NgbModule
                    ]
                }]
        }] });

class FieldHintWrapperComponent {
    constructor(config) {
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: FieldHintWrapperComponent, deps: [{ token: FIELD_CONFIG_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: FieldHintWrapperComponent, selector: "deco-field-hint-wrapper", ngImport: i0, template: "<div class=\"deco-field-hint__container\">\n  <ng-content></ng-content>\n  <label\n    class=\"deco-field-hint__text\"\n  >{{ config.hint }}</label>\n</div>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: FieldHintWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-field-hint-wrapper', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"deco-field-hint__container\">\n  <ng-content></ng-content>\n  <label\n    class=\"deco-field-hint__text\"\n  >{{ config.hint }}</label>\n</div>\n" }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

class FieldTitleWrapperComponent {
    constructor(config) {
        this.config = config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: FieldTitleWrapperComponent, deps: [{ token: FIELD_CONFIG_TOKEN }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: FieldTitleWrapperComponent, selector: "deco-field-title-wrapper", ngImport: i0, template: "<div class=\"deco-field-title\">\n  <label\n    class=\"deco-field-title__label\"\n  >{{ config.title }}</label>\n\n  <div class=\"deco-field-title__field\">\n    <ng-content></ng-content>\n  </div>\n</div>\n", styles: [""], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: FieldTitleWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'deco-field-title-wrapper', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"deco-field-title\">\n  <label\n    class=\"deco-field-title__label\"\n  >{{ config.title }}</label>\n\n  <div class=\"deco-field-title__field\">\n    <ng-content></ng-content>\n  </div>\n</div>\n" }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [FIELD_CONFIG_TOKEN]
                }] }]; } });

const Number = (props) => DecoField(NumberTypeComponent, props);
const Hidden = DecoField(HiddenComponent);
const Text = DecoField(TextTypeComponent);
const Textarea = (props) => DecoField(TextAreaTypeComponent, props);
const Checkbox = DecoField(CheckboxTypeComponent);
// export const Radio = fieldFactory('');
const Select = (props) => DecoField(SelectTypeComponent, props);
const Dropdown = (props) => DecoField(NestedDropdownComponent, props);

const Max = (max) => chain([Prop(NumberTypeComponent, 'max', max), addValidator(Validators.max(max))]);
const Min = (min) => chain([Prop(NumberTypeComponent, 'min', min), addValidator(Validators.min(min + 0.1))]);
const Step = (step) => Prop(NumberTypeComponent, 'step', step);
const Tooltip = (tooltip) => Prop(FieldLabelWrapperComponent, 'tooltip', tooltip);
const Options = (options) => Prop(SelectTypeComponent, 'options$', of(options));
const Label = (label) => chain([
    Wrap(FieldLabelWrapperComponent),
    Prop(FieldLabelWrapperComponent, 'label', label),
    Provide({
        provide: LABEL_TOKEN,
        useFactory: () => inject(targetConfig(FieldLabelWrapperComponent), { skipSelf: true }).label
    })
]);
const CheckLabel = (label) => chain([Wrap(CheckboxLabelWrapperComponent), Prop(CheckboxLabelWrapperComponent, 'label', label)]);
const Hint = (hint) => chain([Wrap(FieldHintWrapperComponent), Prop(FieldHintWrapperComponent, 'hint', hint)]);
const Title = (title) => chain([Wrap(FieldTitleWrapperComponent), Prop(FieldTitleWrapperComponent, 'title', title)]);
// export const Placehodler = (placeholder: string) => Value('placeholder', placeholder);
const Half = Class('etsy-form-field-container-45');
const Third = Class('etsy-form-field-container-35');
const TwoThirds = Class('etsy-form-field-container-60');
const Quarter = Class('etsy-form-field-container-20');
const Hide = (factoryFunc) => chain([Wrap(HideFieldWrapperComponent), PropFactory(HideFieldWrapperComponent, 'hide$', factoryFunc)]);
const Warn = (factoryFunc) => PropFactory(FieldLabelWrapperComponent, 'warning$', factoryFunc);
const Required = Validator(Validators.required);
const Row = Class('deco-group-row');
const Action = (action) => Prop(SubmitComponent, 'label', action);
const BtnClass = (cls) => Prop(SubmitComponent, 'btnClass', cls);
const Submit = (func) => Provide({ provide: FORM_SUBMIT_TOKEN, useFactory: func });
const DropOptions = (fact) => PropFactory(NestedDropdownComponent, 'options$', fact);

/*
 * Public API Surface of ng-deco-forms-bootstrap
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Action, BtnClass, CheckLabel, Checkbox, CheckboxLabelWrapperComponent, CheckboxTypeComponent, DecoFormsBootstrapModule, DropOptions, Dropdown, ErrorPipe, FieldHintWrapperComponent, FieldLabelWrapperComponent, FieldTitleWrapperComponent, ForDirective, Half, Hidden, HiddenComponent, Hide, HideFieldWrapperComponent, Hint, IdDirective, LABEL_TOKEN, Label, Max, Min, NestedDropdownComponent, Number, NumberTypeComponent, Options, PlaceholderDirective, Quarter, Required, Row, SUBMIT_CONFIG_TOKEN, Select, SelectPlaceholderDirective, SelectTypeComponent, Step, Submit, SubmitComponent, Text, TextAreaTypeComponent, TextTypeComponent, Textarea, Third, Title, Tooltip, TwoThirds, Warn };
//# sourceMappingURL=ng-deco-forms-bootstrap.mjs.map
